function [camera_matrix, distortion_coefficients,rectification_matrix,projection_matrix] = CalibRosImport(filename)
%function [fc, cc, alpha_c,kc] = CalibRosImport(filename)
%CalibRosImport('left.yaml')
%filename='left.yaml';
fid = fopen(filename,'r');
state=0;
while(state~=-1) %over
    tline = fgetl(fid) ;
    if tline==-1
        state=-1;
    end
    if strcmp(tline,'camera_matrix:')
        state=1;
    end
    if strcmp(tline,'distortion_coefficients:')
        state=2;
    end
    if strcmp(tline,'rectification_matrix:')
        state=3;
    end
    if strcmp(tline,'projection_matrix:')
        state=4;
    end
    if state==1
        %sscanf(tline,'%s %s',[tname,tvalue]);
        %data: [2338.682315, 0.000000, 693.857413, 0.000000, 2328.085842, 584.210542, 0.000000, 0.000000, 1.000000]
        data=sscanf(tline,' data: [%f, %f, %f, %f, %f, %f, %f, %f, %f');
        if size(data,1)==9
            %             fc(1)=data(1);
            %             cc(1)=data(3);
            %             fc(2)=data(5);
            %             cc(2)=data(6);
            %             alpha_c=0;
            camera_matrix=reshape(data,3,3)';
        end
    end
    if state==2
        data=sscanf(tline,' data: [%f, %f, %f, %f, %f');
        if size(data,1)==5
            distortion_coefficients=data';
        end
    end
    if state==3
        data=sscanf(tline,' data: [%f, %f, %f, %f, %f, %f, %f, %f, %f');
        if size(data,1)==9
            rectification_matrix=reshape(data,3,3)';
        end
    end
    if state==4
        data=sscanf(tline,' data: [%f, %f, %f, %f, %f, %f, %f, %f, %f, %f, %f, %f');
        if size(data,1)==12
            projection_matrix=reshape(data,4,3)';
        end
    end
end
fclose(fid);