%Bertrand VANDEPORTAELE 2016 LAAS CNRS

close all
%clear all

%to find the cornerfinder.m, change this path to the location where you
%have installed the Jean Yves Bouguet Camera Calibration Toolbox
addpath('/media/HD500GO/recupgarossos/home/bvandepo/Bureau/IUT/enseeiht/TPVISION/TOOLBOX_calib_TP/')



[camera_matrix_left, distortion_coefficients_left,rectification_matrix_left,projection_matrix_left] = CalibRosImport('left.yaml')
[camera_matrix_right, distortion_coefficients_right,rectification_matrix_right,projection_matrix_right] = CalibRosImport('right.yaml')
%some data manually extracted from image with the calibration pattern at 1m
%ul=[561, 619, 680, 736, 794, 853, 561  , 561 , 561 , 561  ]
%v=[309, 309, 309, 309, 309, 309, 366 ,  425 , 484 , 541  ]
%ur=[337, 395, 454, 513, 572, 630, 337, 337, 337, 337]

%big calibration pattern
%m=7;
%n=6;
%small calibration pattern
 m=8;
 n=5;

%sizesquare=0.029;

%5 pairs of images have to be acquired from 1 meter away to 5 meter away
%from the stereo bench.
%the images have to be named this way:
% 1m_left.jpg and 1m_right.jpg for 1 meter
% 5m_left.jpg and 5m_right.jpg for 5 meters

%this variable has to be set to chose the pair of images that's gonna be
%used:
 distance=1;
   

if 1 %set to 0 if you do not want to re detect the corners
    for side=0:1
        if side==0
            sideText='left';
        else
            sideText='right';
        end
        nomimin=sprintf('%dm_%s.jpg',distance,sideText);
        imin=imread(nomimin);
        [hautin,largin]=size(imin);
        figure
        imshow(imin); %affichage de l'image
        title('Clickez sur les 4 points dans l''ordre');
        Clicks=ginput(4);
        winty=7; %taille de la fenetre de recherche pour les coins
        wintx=7;
        [ClicksSubPixel,good,bad,type] = cornerfinder([Clicks(:,1)';Clicks(:,2)'],imin,winty,wintx);
        axis ij
        hold on %surimpression par dessus l'image
        plot(ClicksSubPixel(1,:),ClicksSubPixel(2,:),'r+'); %affichage des points clickés en rouge
        title('recovered corners');
        
        [ Hi] = compute2DHomographyUsingDLT( ClicksSubPixel,[0,m-1,m-1,0;0,0,n-1,n-1])
        H=inv(Hi);
        ClicksInterpolated=[];
        for mm=0:m-1
            for nn=0:n-1
                %  if side==0
                %add the 3d coordinates to the vector
                %  Pt3D=[Pt3D;mm*sizesquare,nn*sizesquare,0];
                %  end
                p=[mm,nn,1]';
                pp=H*p;
                pp=pp/pp(3);
                ClicksInterpolated=[ClicksInterpolated;pp(1),pp(2)];
            end
        end
        %refinement
        [ClicksInterpolated,good,bad,type] = cornerfinder([ClicksInterpolated(:,1)';ClicksInterpolated(:,2)'],imin,winty,wintx);
        plot(ClicksInterpolated(1,:),ClicksInterpolated(2,:),'bx'); %affichage des points interpolés en bleu
        colormap('Gray')
        if side==0
            Clicksleft=ClicksInterpolated;
        else
            Clicksright=ClicksInterpolated;
        end
    end
end

ul=Clicksleft(1,:);
ur=Clicksright(1,:);
v=(Clicksleft(2,:)+Clicksright(2,:))/2;


bp=-projection_matrix_right(1,4)
%build the Q matrix as shown in:
% http://docs.ros.org/api/image_geometry/html/c++/stereo__camera__model_8cpp_source.html
Fx=projection_matrix_left(1,1)
Fy=projection_matrix_left(2,2)
Cx=projection_matrix_left(1,3)
Cy=projection_matrix_left(2,3)
%       [ Fx    0  Cx' FxTx ]
%  P' = [ 0     Fy Cy   0    ]
%       [ 0     0  1    0    ]
%baseline in metric unit
Tx=projection_matrix_right(1,4)/Fx
%general case
% Q =   [ Fy*Tx  0     0   -Fy*Cx*Tx    ;
%     0     Fx*Tx  0   -Fx*Cy*Tx     ;
%     0     0     0    Fx*Fy*Tx   ;
%     0     0     -Fy  Fy*(Cx-Cx') ]
%simplified case when Fx=Fy , which is the case with ROS:
Q =    [ 1 0   0      -Cx    ;
    0 1   0       -Cy     ;
    0 0   0       Fx     ;
    0 0 -1/Tx (Cx-Cx')/Tx ]
X=[];
Y=[];
Z=[];

for i=1:size(ul,2)
    disp=ul(i)-ur(i)
    zrelative=bp/disp
    Ql=[ul(i);v(i);disp;1]
    Qr=Q*Ql;
    Qr=Qr/Qr(4)
    X=[X,Qr(1)];
    Y=[Y,Qr(2)];
    Z=[Z,Qr(3)];
end

figure
plot3(X,Y,Z,'r+');
hold on
axis equal
[n,V,p] = affine_fit([X;Y;Z]')
%second plane
%NB: if the plane is vertical the above method cannot be used, one should
%use the secont output of affine_fit which contains a base of the plane.
%this is illustrated below
%S1 and S2 are the coordinates of the plane points in the basis made of the
%columns ov V_2
[S1,S2] = meshgrid([-1 0 1]);
%generate the pont coordinates
Xp = p(1)+[S1(:) S2(:)]*V(1,:)';
Yp = p(2)+[S1(:) S2(:)]*V(2,:)';
Zp = p(3)+[S1(:) S2(:)]*V(3,:)';
%plot the plane
surf(reshape(Xp,3,3),reshape(Yp,3,3),reshape(Zp,3,3),'facecolor','blue','facealpha',0.5);

plot3(Xp,Yp,Zp,'g+');
xlabel('x');
ylabel('y');
zlabel('z');
%compute the d parameter of the plane
d=-p*n

Zmean=mean(Z)
err=[];
for i=1:size(X,2)
    %compute the distance of the point to the plane, assuming n is
    %normalized
    err(i)=    n'*[X(i);Y(i);Z(i)]+d;
end
figure
plot(err);
title('error in Z direction relatively to the fitted plane');
%standard deviation
stdev=sqrt(var(err))